<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>frontend documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">frontend documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content component">
                   <div class="content-data">




<ol class="breadcrumb">
  <li>Components</li>
  <li>DocumentEditComponent</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
        <li >
            <a href="#templateData" role="tab" id="templateData-tab" data-toggle="tab" data-link="template">Template</a>
        </li>
        <li >
            <a href="#styleData" role="tab" id="styleData-tab" data-toggle="tab" data-link="style">Styles</a>
        </li>
        <li >
            <a href="#tree" role="tab" id="tree-tab" data-toggle="tab" data-link="dom-tree">DOM Tree</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info"><p class="comment">
    <h3>File</h3>
</p>
<p class="comment">
    <code>src/app/operation/parameters/document/document-edit.component.ts</code>
</p>



    <p class="comment">
        <h3>Implements</h3>
    </p>
    <p class="comment">
                <code><a href="https://angular.io/api/core/OnInit" target="_blank" >OnInit</a></code>
                <code><a href="../interfaces/ConfirmBeforeQuit.html" target="_self" >ConfirmBeforeQuit</a></code>
    </p>


<section>
    <h3>Metadata</h3>
    <table class="table table-sm table-hover">
        <tbody>












            <tr>
                <td class="col-md-3">styleUrls</td>
                <td class="col-md-9"><code>../parameter-edit.scss,<br>./document-edit.component.scss</code></td>
            </tr>



            <tr>
                <td class="col-md-3">templateUrl</td>
                <td class="col-md-9"><code>./document-edit.component.html</code></td>
            </tr>








        </tbody>
    </table>
</section>

    <section>
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>
                <tr>
                    <td class="col-md-4">
                        <h6><b>Properties</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#_readOnly">_readOnly</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#_subscriptions">_subscriptions</a>
                            </li>
                            <li>
                                <a href="#documentForm">documentForm</a>
                            </li>
                            <li>
                                <a href="#documents">documents</a>
                            </li>
                            <li>
                                <a href="#documentsDataSource">documentsDataSource</a>
                            </li>
                            <li>
                                <a href="#documentTypes">documentTypes</a>
                            </li>
                            <li>
                                <a href="#languages">languages</a>
                            </li>
                            <li>
                                <a href="#operation">operation</a>
                            </li>
                            <li>
                                <a href="#questionListComponent">questionListComponent</a>
                            </li>
                            <li>
                                <a href="#sort">sort</a>
                            </li>
                            <li>
                                <a href="#uploadInputComponent">uploadInputComponent</a>
                            </li>
                        </ul>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <h6><b>Methods</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                <a href="#checkBeforeUpload">checkBeforeUpload</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#createForm">createForm</a>
                            </li>
                            <li>
                                <a href="#deleteFile">deleteFile</a>
                            </li>
                            <li>
                                <a href="#download">download</a>
                            </li>
                            <li>
                                <a href="#isFormModified">isFormModified</a>
                            </li>
                            <li>
                                <a href="#ngOnDestroy">ngOnDestroy</a>
                            </li>
                            <li>
                                <a href="#ngOnInit">ngOnInit</a>
                            </li>
                            <li>
                                <a href="#processUploadResult">processUploadResult</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#removeDocument">removeDocument</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#updateLanguages">updateLanguages</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#updateTypes">updateTypes</a>
                            </li>
                        </ul>
                    </td>
                </tr>





                    <tr>
                        <td class="col-md-4">
                            <h6><b>Accessors</b></h6>
                        </td>
                    </tr>
                    <tr>
                        <td class="col-md-4">
                            <ul class="index-list">
                                <li>
                                    <a href="#readOnly">readOnly</a>
                                </li>
                                <li>
                                    <a href="#allDocumentsAreImported">allDocumentsAreImported</a>
                                </li>
                                <li>
                                    <a href="#documentsDisplayedColumns">documentsDisplayedColumns</a>
                                </li>
                                <li>
                                    <a href="#uploadUrl">uploadUrl</a>
                                </li>
                            </ul>
                        </td>
                    </tr>
        </tbody>
    </table>
</section>

    <section>
    <h3 id="constructor">Constructor</h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
<code>constructor(formBuilder: <a href="https://angular.io/api/forms/FormBuilder" target="_blank">FormBuilder</a>, parametersModel: <a href="../injectables/OperationParametersModel.html">OperationParametersModel</a>, documentService: <a href="../injectables/DocumentService.html">DocumentService</a>, dialogService: TdDialogService, translateService: TranslateService, fileService: <a href="../injectables/FileService.html">FileService</a>, authorizationService: <a href="../injectables/AuthorizationService.html">AuthorizationService</a>, readOnlyService: <a href="../injectables/ReadOnlyService.html">ReadOnlyService</a>, snackBar: MatSnackBar)</code>
                    </td>
                </tr>
                        <tr>
                            <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="53" class="link-to-prism">src/app/operation/parameters/document/document-edit.component.ts:53</a></div>
                            </td>
                        </tr>

                <tr>
                    <td class="col-md-4">
                            <div>
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>formBuilder</td>
                                                  
                                                        <td>
                                                                    <code><a href="https://angular.io/api/forms/FormBuilder" target="_blank" >FormBuilder</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>parametersModel</td>
                                                  
                                                        <td>
                                                                    <code><a href="../injectables/OperationParametersModel.html" target="_self" >OperationParametersModel</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>documentService</td>
                                                  
                                                        <td>
                                                                    <code><a href="../injectables/DocumentService.html" target="_self" >DocumentService</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>dialogService</td>
                                                  
                                                        <td>
                                                                    <code>TdDialogService</code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>translateService</td>
                                                  
                                                        <td>
                                                                    <code>TranslateService</code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>fileService</td>
                                                  
                                                        <td>
                                                                    <code><a href="../injectables/FileService.html" target="_self" >FileService</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>authorizationService</td>
                                                  
                                                        <td>
                                                                    <code><a href="../injectables/AuthorizationService.html" target="_self" >AuthorizationService</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>readOnlyService</td>
                                                  
                                                        <td>
                                                                    <code><a href="../injectables/ReadOnlyService.html" target="_self" >ReadOnlyService</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>snackBar</td>
                                                  
                                                        <td>
                                                                    <code>MatSnackBar</code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>





    <section>
    
        <h3 id="methods">
            Methods
        </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="checkBeforeUpload"></a>
                        <span class="name">
                            <b>
                            checkBeforeUpload
                            </b>
                            <a href="#checkBeforeUpload"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>checkBeforeUpload()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="130" class="link-to-prism">src/app/operation/parameters/document/document-edit.component.ts:130</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code>() &#x3D;&gt; any</code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="createForm"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            createForm
                            </b>
                            <a href="#createForm"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                            <span class="modifier-icon icon ion-ios-reset"></span>
                        <code>createForm()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="226" class="link-to-prism">src/app/operation/parameters/document/document-edit.component.ts:226</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="deleteFile"></a>
                        <span class="name">
                            <b>
                            deleteFile
                            </b>
                            <a href="#deleteFile"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>deleteFile(document: <a href="../classes/OperationFile.html">OperationFile</a>)</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="173" class="link-to-prism">src/app/operation/parameters/document/document-edit.component.ts:173</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>document</td>
                                                        <td>
                                                                    <code><a href="../classes/OperationFile.html" target="_self" >OperationFile</a></code>
                                                        </td>
                                                    
                                                    <td>
                                                            No
                                                    </td>
                                                    

                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                            <div>
                            </div>
                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                            </div>
                                <div class="io-description">
                                    
                                </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="download"></a>
                        <span class="name">
                            <b>
                            download
                            </b>
                            <a href="#download"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>download(e, document: <a href="../classes/OperationFile.html">OperationFile</a>)</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="166" class="link-to-prism">src/app/operation/parameters/document/document-edit.component.ts:166</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>e</td>
                                                        <td>
                                                        </td>
                                                    
                                                    <td>
                                                            No
                                                    </td>
                                                    

                                                </tr>
                                                <tr>
                                                        <td>document</td>
                                                        <td>
                                                                    <code><a href="../classes/OperationFile.html" target="_self" >OperationFile</a></code>
                                                        </td>
                                                    
                                                    <td>
                                                            No
                                                    </td>
                                                    

                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                            <div>
                            </div>
                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                            </div>
                                <div class="io-description">
                                    
                                </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="isFormModified"></a>
                        <span class="name">
                            <b>
                            isFormModified
                            </b>
                            <a href="#isFormModified"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>isFormModified()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="117" class="link-to-prism">src/app/operation/parameters/document/document-edit.component.ts:117</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/boolean" target="_blank" >boolean</a></code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="ngOnDestroy"></a>
                        <span class="name">
                            <b>
                            ngOnDestroy
                            </b>
                            <a href="#ngOnDestroy"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>ngOnDestroy()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="126" class="link-to-prism">src/app/operation/parameters/document/document-edit.component.ts:126</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="ngOnInit"></a>
                        <span class="name">
                            <b>
                            ngOnInit
                            </b>
                            <a href="#ngOnInit"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>ngOnInit()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="68" class="link-to-prism">src/app/operation/parameters/document/document-edit.component.ts:68</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="processUploadResult"></a>
                        <span class="name">
                            <b>
                            processUploadResult
                            </b>
                            <a href="#processUploadResult"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>processUploadResult(document: <a href="../classes/OperationFile.html">OperationFile</a>)</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="139" class="link-to-prism">src/app/operation/parameters/document/document-edit.component.ts:139</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>document</td>
                                                        <td>
                                                                    <code><a href="../classes/OperationFile.html" target="_self" >OperationFile</a></code>
                                                        </td>
                                                    
                                                    <td>
                                                            No
                                                    </td>
                                                    

                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                            <div>
                            </div>
                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                            </div>
                                <div class="io-description">
                                    
                                </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="removeDocument"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            removeDocument
                            </b>
                            <a href="#removeDocument"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                            <span class="modifier-icon icon ion-ios-reset"></span>
                        <code>removeDocument(documentId: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/number" target="_blank">number</a>)</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="220" class="link-to-prism">src/app/operation/parameters/document/document-edit.component.ts:220</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>documentId</td>
                                                        <td>
                                                                    <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/number" target="_blank" >number</a></code>
                                                        </td>
                                                    
                                                    <td>
                                                            No
                                                    </td>
                                                    

                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                            <div>
                            </div>
                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                            </div>
                                <div class="io-description">
                                    
                                </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="updateLanguages"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            updateLanguages
                            </b>
                            <a href="#updateLanguages"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                            <span class="modifier-icon icon ion-ios-reset"></span>
                        <code>updateLanguages()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="209" class="link-to-prism">src/app/operation/parameters/document/document-edit.component.ts:209</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="updateTypes"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            updateTypes
                            </b>
                            <a href="#updateTypes"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                            <span class="modifier-icon icon ion-ios-reset"></span>
                        <code>updateTypes()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="198" class="link-to-prism">src/app/operation/parameters/document/document-edit.component.ts:198</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>

    <section>
    
        <h3 id="inputs">
            Properties
        </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="_readOnly"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            _readOnly
                            </b>
                            <a href="#_readOnly"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <span class="modifier-icon icon ion-ios-reset"></span><code>_readOnly:     <code></code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>false</code>
                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="53" class="link-to-prism">src/app/operation/parameters/document/document-edit.component.ts:53</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="_subscriptions"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            _subscriptions
                            </b>
                            <a href="#_subscriptions"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <span class="modifier-icon icon ion-ios-reset"></span><code>_subscriptions:     <code>Subscription[]</code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code>Subscription[]</code>

                        </td>
                    </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>[]</code>
                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="52" class="link-to-prism">src/app/operation/parameters/document/document-edit.component.ts:52</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="documentForm"></a>
                        <span class="name">
                            <b>
                            documentForm
                            </b>
                            <a href="#documentForm"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <code>documentForm:     <code><a href="https://angular.io/api/forms/FormGroup" target="_blank" >FormGroup</a></code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code><a href="https://angular.io/api/forms/FormGroup" target="_blank" >FormGroup</a></code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="50" class="link-to-prism">src/app/operation/parameters/document/document-edit.component.ts:50</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="documents"></a>
                        <span class="name">
                            <b>
                            documents
                            </b>
                            <a href="#documents"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <code>documents:     <code><a href="../classes/OperationFile.html" target="_self" >OperationFile[]</a></code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code><a href="../classes/OperationFile.html" target="_self" >OperationFile[]</a></code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="44" class="link-to-prism">src/app/operation/parameters/document/document-edit.component.ts:44</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="documentsDataSource"></a>
                        <span class="name">
                            <b>
                            documentsDataSource
                            </b>
                            <a href="#documentsDataSource"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <code>documentsDataSource:     <code><a href="../classes/DocumentsDataSource.html" target="_self" >DocumentsDataSource</a></code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code><a href="../classes/DocumentsDataSource.html" target="_self" >DocumentsDataSource</a></code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="51" class="link-to-prism">src/app/operation/parameters/document/document-edit.component.ts:51</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="documentTypes"></a>
                        <span class="name">
                            <b>
                            documentTypes
                            </b>
                            <a href="#documentTypes"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <code>documentTypes:     <code></code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>ALL_TYPES</code>
                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="48" class="link-to-prism">src/app/operation/parameters/document/document-edit.component.ts:48</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="languages"></a>
                        <span class="name">
                            <b>
                            languages
                            </b>
                            <a href="#languages"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <code>languages:     <code></code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>ALL_LANGUAGES</code>
                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="49" class="link-to-prism">src/app/operation/parameters/document/document-edit.component.ts:49</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="operation"></a>
                        <span class="name">
                            <b>
                            operation
                            </b>
                            <a href="#operation"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <code>operation:     <code><a href="../classes/Operation.html" target="_self" >Operation</a></code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code><a href="../classes/Operation.html" target="_self" >Operation</a></code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="43" class="link-to-prism">src/app/operation/parameters/document/document-edit.component.ts:43</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="questionListComponent"></a>
                        <span class="name">
                            <b>
                            questionListComponent
                            </b>
                            <a href="#questionListComponent"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <code>questionListComponent:     <code><a href="../interfaces/HighlightedQuestion.html" target="_self" >HighlightedQuestionListComponent</a></code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code><a href="../interfaces/HighlightedQuestion.html" target="_self" >HighlightedQuestionListComponent</a></code>

                        </td>
                    </tr>
                    <tr>
                        <td class="col-md-4">
                            <b>Decorators : </b>
                            <br />
                            <code>
                                @ViewChild(HighlightedQuestionListComponent)<br />
                            </code>
                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="47" class="link-to-prism">src/app/operation/parameters/document/document-edit.component.ts:47</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="sort"></a>
                        <span class="name">
                            <b>
                            sort
                            </b>
                            <a href="#sort"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <code>sort:     <code>MatSort</code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code>MatSort</code>

                        </td>
                    </tr>
                    <tr>
                        <td class="col-md-4">
                            <b>Decorators : </b>
                            <br />
                            <code>
                                @ViewChild(MatSort)<br />
                            </code>
                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="45" class="link-to-prism">src/app/operation/parameters/document/document-edit.component.ts:45</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="uploadInputComponent"></a>
                        <span class="name">
                            <b>
                            uploadInputComponent
                            </b>
                            <a href="#uploadInputComponent"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <code>uploadInputComponent:     <code><a href="../classes/UploadInput.html" target="_self" >UploadInputComponent</a></code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code><a href="../classes/UploadInput.html" target="_self" >UploadInputComponent</a></code>

                        </td>
                    </tr>
                    <tr>
                        <td class="col-md-4">
                            <b>Decorators : </b>
                            <br />
                            <code>
                                @ViewChild(UploadInputComponent)<br />
                            </code>
                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="46" class="link-to-prism">src/app/operation/parameters/document/document-edit.component.ts:46</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
</section>

    <section>
    <h3 id="accessors">
        Accessors
    </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="readOnly"></a>
                        <span class="name"><b>readOnly</b><a href="#readOnly"><span class="icon ion-ios-link"></span></a></span>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <span class="accessor"><b>get</b><code>readOnly()</code></span>
                    </td>
                </tr>
                            <tr>
                                <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="96" class="link-to-prism">src/app/operation/parameters/document/document-edit.component.ts:96</a></div>
                                </td>
                            </tr>

            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="allDocumentsAreImported"></a>
                        <span class="name"><b>allDocumentsAreImported</b><a href="#allDocumentsAreImported"><span class="icon ion-ios-link"></span></a></span>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <span class="accessor"><b>get</b><code>allDocumentsAreImported()</code></span>
                    </td>
                </tr>
                            <tr>
                                <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="101" class="link-to-prism">src/app/operation/parameters/document/document-edit.component.ts:101</a></div>
                                </td>
                            </tr>

            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="documentsDisplayedColumns"></a>
                        <span class="name"><b>documentsDisplayedColumns</b><a href="#documentsDisplayedColumns"><span class="icon ion-ios-link"></span></a></span>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <span class="accessor"><b>get</b><code>documentsDisplayedColumns()</code></span>
                    </td>
                </tr>
                            <tr>
                                <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="105" class="link-to-prism">src/app/operation/parameters/document/document-edit.component.ts:105</a></div>
                                </td>
                            </tr>

            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="uploadUrl"></a>
                        <span class="name"><b>uploadUrl</b><a href="#uploadUrl"><span class="icon ion-ios-link"></span></a></span>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <span class="accessor"><b>get</b><code>uploadUrl()</code></span>
                    </td>
                </tr>
                            <tr>
                                <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="113" class="link-to-prism">src/app/operation/parameters/document/document-edit.component.ts:113</a></div>
                                </td>
                            </tr>

            </tbody>
        </table>
</section>
</div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { Component, OnInit, ViewChild } from &quot;@angular/core&quot;;
import { FormBuilder, FormGroup, Validators } from &quot;@angular/forms&quot;;
import { OperationParametersModel } from &quot;../model/operation-parameters.model&quot;;
import { OperationFile } from &quot;../../../core/model/operation-file&quot;;
import { Operation } from &quot;../../model/operation&quot;;
import { DocumentService } from &quot;./service/document.service&quot;;
import { Observable } from &quot;rxjs/Observable&quot;;
import { DataSource } from &quot;@angular/cdk/collections&quot;;
import { MatSnackBar, MatSort, MatSortable } from &quot;@angular/material&quot;;
import { sortOnProperty } from &quot;../../../core/util/table-utils&quot;;
import { TranslateService } from &quot;@ngx-translate/core&quot;;
import { TdDialogService } from &quot;@covalent/core&quot;;
import * as _ from &quot;underscore&quot;;
import { FileService } from &quot;app/core/service/file-service/file-service&quot;;
import { map } from &quot;rxjs/operators&quot;;
import { merge } from &quot;rxjs/observable/merge&quot;;
import { AuthorizationService } from &quot;../../../core/service/http/authorization.service&quot;;
import { ConfirmBeforeQuit } from &quot;../../../core/confirm-before-quit&quot;;
import { UploadInputComponent } from &quot;../../../shared/upload-input/upload-input.component&quot;;
import { Subscription } from &quot;rxjs/Subscription&quot;;
import { ReadOnlyService } from &quot;../../service/read-only.service&quot;;
import { HighlightedQuestionListComponent } from &quot;./highlighted-question/components/highlighted-question-list.component&quot;;
import { isFormModifiedAndNotSaved } from &#x27;../../../core/util/form-utils&#x27;;

const ALL_TYPES &#x3D; [
  {value: &#x27;DOCUMENT_FAQ&#x27;, labelKey: &#x27;parameters.document.edit.form.fields.type.label-key.DOCUMENT_FAQ&#x27;},
  {value: &#x27;DOCUMENT_TERMS&#x27;, labelKey: &#x27;parameters.document.edit.form.fields.type.label-key.DOCUMENT_TERMS&#x27;},
  {value: &#x27;DOCUMENT_CERTIFICATE&#x27;, labelKey: &#x27;parameters.document.edit.form.fields.type.label-key.DOCUMENT_CERTIFICATE&#x27;}
];

const ALL_LANGUAGES &#x3D; [
  {value: &#x27;DE&#x27;, labelKey: &#x27;parameters.document.edit.form.fields.language.label-key.DE&#x27;},
  {value: &#x27;FR&#x27;, labelKey: &#x27;parameters.document.edit.form.fields.language.label-key.FR&#x27;},
  {value: &#x27;IT&#x27;, labelKey: &#x27;parameters.document.edit.form.fields.language.label-key.IT&#x27;},
  {value: &#x27;RM&#x27;, labelKey: &#x27;parameters.document.edit.form.fields.language.label-key.RM&#x27;}
];

@Component({
  templateUrl: &#x27;./document-edit.component.html&#x27;,
  styleUrls: [&#x27;../parameter-edit.scss&#x27;, &#x27;./document-edit.component.scss&#x27;]
})
export class DocumentEditComponent implements OnInit, ConfirmBeforeQuit {
  operation: Operation;
  documents: OperationFile[];
  @ViewChild(MatSort) sort: MatSort;
  @ViewChild(UploadInputComponent) uploadInputComponent: UploadInputComponent;
  @ViewChild(HighlightedQuestionListComponent) questionListComponent: HighlightedQuestionListComponent;
  documentTypes &#x3D; ALL_TYPES;
  languages &#x3D; ALL_LANGUAGES;
  documentForm: FormGroup;
  documentsDataSource: DocumentsDataSource;
  private _subscriptions: Subscription[] &#x3D; [];
  private _readOnly &#x3D; false;

  constructor(private formBuilder: FormBuilder,
              private parametersModel: OperationParametersModel,
              private documentService: DocumentService,
              private dialogService: TdDialogService,
              private translateService: TranslateService,
              private fileService: FileService,
              private authorizationService: AuthorizationService,
              private readOnlyService: ReadOnlyService,
              private snackBar: MatSnackBar) {
    this.createForm();
    this.documentForm.reset({documentType: null, documentLanguage: null});
  }

  ngOnInit() {

    this._subscriptions.push(
      this.readOnlyService.isDocumentInReadOnly()
        .subscribe(
          readOnly &#x3D;&gt; {
            this._readOnly &#x3D; readOnly;
          }
        ),
      this.parametersModel.currentOperation.subscribe(operation &#x3D;&gt; this.operation &#x3D; operation),
      this.parametersModel.currentDocumentFiles.subscribe(documents &#x3D;&gt; this.documents &#x3D; documents));

    this.documentsDataSource &#x3D; new DocumentsDataSource(this.parametersModel, this.sort, this.translateService);
    this.updateTypes();
    this.updateLanguages();

    //The first sort is done on ballotId column
    // To conform to the SFD, the second column to be sorted is language but matsort doesn&#x27;t support this feature yet.
    // An issue is opened for this purpose
    // TODO : https://github.com/angular/material2/issues/7226
    this.sort.sort(&lt;MatSortable&gt;{
        id: &quot;type&quot;,
        start: &quot;asc&quot;,
      }
    );
  }


  get readOnly(): boolean {
    return this._readOnly;
  }


  get allDocumentsAreImported() {
    return this.documents &amp;&amp; this.documents.length &#x3D;&#x3D; ALL_TYPES.length * ALL_LANGUAGES.length;
  }

  get documentsDisplayedColumns() {
    let readableColumn &#x3D; [&#x27;type&#x27;, &#x27;language&#x27;, &#x27;file&#x27;];
    if (!this.readOnly &amp;&amp; this.authorizationService.hasAtLeastOneRole([&#x27;DELETE_OPERATION_DOCUMENTATION&#x27;])) {
      return readableColumn.concat([&#x27;delete&#x27;]);
    }
    return readableColumn;
  }

  get uploadUrl(): string {
    return &#x60;${this.documentService.serviceUrl}/${this.operation.id}/upload/${this.documentForm.value.documentType}/${this.documentForm.value.documentLanguage}&#x60;;
  }

  isFormModified(): boolean {
    return this.questionListComponent.inEdition ||
           this.uploadInputComponent &amp;&amp;
           (this.uploadInputComponent.isFormModified() ||
           isFormModifiedAndNotSaved(this.documentForm, false));
  }



  ngOnDestroy(): void {
    this._subscriptions.forEach(s &#x3D;&gt; s.unsubscribe());
  }

  checkBeforeUpload() {
    return () &#x3D;&gt; {
      this.documentForm.controls.documentType.markAsTouched();
      this.documentForm.controls.documentLanguage.markAsTouched();
      this.documentForm.updateValueAndValidity();
      return this.documentForm.valid;
    }
  }

  processUploadResult(document: OperationFile) {
    if (document) {
      let existingDocument &#x3D; _.find(this.documents, doc &#x3D;&gt; {
        return doc.businessKey &#x3D;&#x3D;&#x3D; document.businessKey;
      });
      if (existingDocument) {
        this.removeDocument(existingDocument.id);
      }
      this.documents.push(document);
      this.parametersModel.updateDocumentFiles(this.documents);
      // UI-feedback: notify user that import was successful
      this.snackBar.open(
        this.translateService.instant(
          &#x27;parameters.document.edit.form.import-success&#x27;,
          {fileName: document.fileName}
        ),
        &#x27;&#x27;,
        {
          duration: 5000
        }
      );
      this.documentForm.reset({documentType: null, documentLanguage: null});
      this.updateTypes();
      this.updateLanguages();
    }
  }

  download(e, document: OperationFile) {
    this.documentService.download(document.id).subscribe(blob &#x3D;&gt; {
      this.fileService.downloadBlob(document.fileName, blob)
    });
    e.preventDefault();
  }

  deleteFile(document: OperationFile) {
    this.dialogService.openConfirm({
      message: this.translateService.instant(&#x27;parameters.document.edit.delete-dialog.message&#x27;,
        {fileName: document.fileName}),
      disableClose: true,
      cancelButton: this.translateService.instant(&#x27;global.actions.no&#x27;),
      acceptButton: this.translateService.instant(&#x27;global.actions.yes&#x27;),
    }).afterClosed().subscribe((accept: boolean) &#x3D;&gt; {
      if (accept) {
        this.documentService.deleteFile(document.id).subscribe(() &#x3D;&gt; {
          this.snackBar.open(
            this.translateService.instant(
              &#x27;parameters.document.edit.delete-success&#x27;, {fileName: document.fileName}),
            &#x27;&#x27;,
            {duration: 5000}
          );
          this.removeDocument(document.id);
          this.parametersModel.updateDocumentFiles(this.documents);
          this.updateTypes();
          this.updateLanguages();
        });
      }
    });
  }

  private updateTypes() {
    let documentLanguage &#x3D; this.documentForm.controls.documentLanguage.value;
    if (documentLanguage) {
      let documentsByTypes &#x3D; this.documents.filter(document &#x3D;&gt; document.language &#x3D;&#x3D; documentLanguage)
        .map(document &#x3D;&gt; document.type);
      this.documentTypes &#x3D; ALL_TYPES.filter(type &#x3D;&gt; documentsByTypes.indexOf(type.value) &#x3D;&#x3D; -1);
    } else {
      this.documentTypes &#x3D; ALL_TYPES;
    }
  }

  private updateLanguages() {
    let documentType &#x3D; this.documentForm.controls.documentType.value;
    if (documentType) {
      let documentsByLanguages &#x3D; this.documents.filter(document &#x3D;&gt; document.type &#x3D;&#x3D; documentType)
        .map(document &#x3D;&gt; document.language);
      this.languages &#x3D; ALL_LANGUAGES.filter(language &#x3D;&gt; documentsByLanguages.indexOf(language.value) &#x3D;&#x3D; -1);
    } else {
      this.languages &#x3D; ALL_LANGUAGES;
    }
  }

  private removeDocument(documentId: number) {
    this.documents &#x3D; _.reject(this.documents, function (document: OperationFile) {
      return document.id &#x3D;&#x3D;&#x3D; documentId;
    });
  }

  private createForm() {
    this.documentForm &#x3D; this.formBuilder.group({
      documentType: [
        {value: null},
        Validators.required
      ],
      documentLanguage: [
        {value: null},
        Validators.required
      ]
    })
  }
}

class DocumentsDataSource extends DataSource&lt;OperationFile&gt; {

  private documents: OperationFile[];

  constructor(private parametersModel: OperationParametersModel,
              private sort: MatSort,
              private translateService: TranslateService) {
    super();
    this.parametersModel.currentDocumentFiles.subscribe(files &#x3D;&gt; this.documents &#x3D; files);
  }

  connect(): Observable&lt;OperationFile[]&gt; {
    return merge(this.parametersModel.currentDocumentFiles, this.sort.sortChange,
      this.translateService.onLangChange).pipe(
      map(() &#x3D;&gt; this.translate(this.documents)),
      map((documents) &#x3D;&gt; sortOnProperty(documents, this.sort.active, this.sort.direction))
    )
  }

  disconnect() {
  }

  private translate(documents: OperationFile[]) {
    return documents.map(document &#x3D;&gt; Object.assign(
      {},
      document,
      {
        language: this.translateService.instant(
          &#x60;parameters.document.edit.form.fields.language.label-key.${document.language}&#x60;),
        type: this.translateService.instant(
          &#x60;parameters.document.edit.form.fields.type.label-key.${document.type}&#x60;)
      }));
  }
}
</code></pre>
    </div>

    <div class="tab-pane fade " id="c-templateData">
        <pre class="line-numbers"><code class="language-html">&lt;mat-card id&#x3D;&quot;documentEdit&quot; class&#x3D;&quot;parameter-edit&quot; [class.read-only]&#x3D;&quot;readOnly&quot;&gt;
  &lt;mat-card-header&gt;
    &lt;mat-card-title&gt;{{&#x27;parameters.document.edit.title&#x27; | translate}}&lt;/mat-card-title&gt;
    &lt;mat-card-subtitle fxLayout&#x3D;&quot;row&quot; fxLayoutAlign&#x3D;&quot;space-between&quot;&gt;
      &lt;span&gt;{{&#x27;parameters.document.edit.subtitle&#x27; | translate}}&lt;/span&gt;
      &lt;span *ngIf&#x3D;&quot;!readOnly&quot;&gt;{{&#x27;global.forms.fields.required&#x27; | translate}}&lt;/span&gt;
    &lt;/mat-card-subtitle&gt;
  &lt;/mat-card-header&gt;
  &lt;mat-card-content class&#x3D;&quot;no-padding&quot;&gt;

    &lt;ng-container *roles&#x3D;&quot;[&#x27;SET_OPERATION_DOCUMENTATION&#x27;]&quot;&gt;

      &lt;div fxLayout fxLayoutGap&#x3D;&quot;25px&quot; class&#x3D;&quot;parameter-input&quot; *ngIf&#x3D;&quot;!readOnly &amp;&amp; !allDocumentsAreImported&quot;&gt;
        &lt;form [formGroup]&#x3D;&quot;documentForm&quot; novalidate&gt;
          &lt;div fxLayout fxLayoutGap&#x3D;&quot;25px&quot;&gt;
            &lt;mat-form-field fxFlex&#x3D;&quot;1 1 200px&quot;&gt;
              &lt;mat-select [placeholder]&#x3D;&quot;&#x27;parameters.document.edit.form.fields.type.placeholder&#x27; | translate&quot;
                          formControlName&#x3D;&quot;documentType&quot;
                          (selectionChange)&#x3D;&quot;updateLanguages()&quot;
                          required&gt;
                &lt;mat-option *ngFor&#x3D;&quot;let type of documentTypes&quot; [value]&#x3D;&quot;type.value&quot;&gt;
                  {{type.labelKey | translate}}
                &lt;/mat-option&gt;
              &lt;/mat-select&gt;
              &lt;mat-error
                *ngIf&#x3D;&quot;documentForm.get(&#x27;documentType&#x27;).touched &amp;&amp; documentForm.get(&#x27;documentType&#x27;).hasError(&#x27;required&#x27;)&quot;&gt;
                {{&#x27;global.forms.errors.required&#x27; | translate}}
              &lt;/mat-error&gt;
            &lt;/mat-form-field&gt;

            &lt;mat-form-field fxFlex&#x3D;&quot;1 1 200px&quot;&gt;
              &lt;mat-select [placeholder]&#x3D;&quot;&#x27;parameters.document.edit.form.fields.language.placeholder&#x27; | translate&quot;
                          formControlName&#x3D;&quot;documentLanguage&quot;
                          (selectionChange)&#x3D;&quot;updateTypes()&quot;
                          required&gt;
                &lt;mat-option *ngFor&#x3D;&quot;let lang of languages&quot; [value]&#x3D;&quot;lang.value&quot;&gt;
                  {{lang.labelKey | translate}}
                &lt;/mat-option&gt;
              &lt;/mat-select&gt;
              &lt;mat-error
                *ngIf&#x3D;&quot;documentForm.get(&#x27;documentLanguage&#x27;).touched &amp;&amp; documentForm.get(&#x27;documentLanguage&#x27;).hasError(&#x27;required&#x27;)&quot;&gt;
                {{&#x27;global.forms.errors.required&#x27; | translate}}
              &lt;/mat-error&gt;
            &lt;/mat-form-field&gt;
          &lt;/div&gt;
        &lt;/form&gt;

        &lt;upload-input fxFlex&#x3D;&quot;auto&quot; placeholder&#x3D;&quot;parameters.document.edit.form.fields.inputFile.placeholder&quot;
                      [uploadUrl]&#x3D;&quot;uploadUrl&quot;
                      [checkBeforeUpload]&#x3D;&quot;checkBeforeUpload()&quot;
                      fileAccept&#x3D;&quot;.pdf&quot;
                      uploadIcon&#x3D;&quot;file_upload&quot;
                      uploadText&#x3D;&quot;global.actions.import&quot;
                      progressText&#x3D;&quot;global.upload-progress&quot;
                      (uploadDone)&#x3D;&quot;processUploadResult($event)&quot;&gt;
        &lt;/upload-input&gt;
      &lt;/div&gt;


    &lt;/ng-container&gt;

    &lt;mat-table [hidden]&#x3D;&quot;!documents || documents.length &#x3D;&#x3D;&#x3D; 0&quot;
               [dataSource]&#x3D;&quot;documentsDataSource&quot; matSort
               id&#x3D;&quot;documentsGrid&quot;&gt;

      &lt;ng-container matColumnDef&#x3D;&quot;type&quot;&gt;
        &lt;mat-header-cell *matHeaderCellDef mat-sort-header&gt;
          {{&quot;parameters.document.edit.grid.header.type&quot; | translate}}
        &lt;/mat-header-cell&gt;
        &lt;mat-cell *matCellDef&#x3D;&quot;let file&quot;&gt;{{file.type}}&lt;/mat-cell&gt;
      &lt;/ng-container&gt;

      &lt;ng-container matColumnDef&#x3D;&quot;language&quot;&gt;
        &lt;mat-header-cell *matHeaderCellDef mat-sort-header&gt;
          {{&quot;parameters.document.edit.grid.header.language&quot; | translate}}
        &lt;/mat-header-cell&gt;
        &lt;mat-cell *matCellDef&#x3D;&quot;let file&quot;&gt;{{file.language}}&lt;/mat-cell&gt;
      &lt;/ng-container&gt;

      &lt;ng-container matColumnDef&#x3D;&quot;file&quot;&gt;
        &lt;mat-header-cell *matHeaderCellDef mat-sort-header&gt;
          {{&quot;parameters.document.edit.grid.header.file&quot; | translate}}
        &lt;/mat-header-cell&gt;
        &lt;mat-cell *matCellDef&#x3D;&quot;let file&quot;&gt;&lt;a href&#x3D;&quot;#&quot; (click)&#x3D;&quot;download($event, file)&quot;&gt;{{file.fileName}}&lt;/a&gt;&lt;/mat-cell&gt;
      &lt;/ng-container&gt;

      &lt;ng-container matColumnDef&#x3D;&quot;delete&quot;&gt;
        &lt;mat-header-cell *matHeaderCellDef&gt;
          {{&quot;parameters.document.edit.grid.header.delete&quot; | translate}}
        &lt;/mat-header-cell&gt;
        &lt;mat-cell *matCellDef&#x3D;&quot;let file&quot;&gt;
          &lt;button mat-icon-button
                  color&#x3D;&quot;accent&quot;
                  (click)&#x3D;&quot;deleteFile(file)&quot;&gt;
            &lt;mat-icon&gt;clear&lt;/mat-icon&gt;
          &lt;/button&gt;
        &lt;/mat-cell&gt;
      &lt;/ng-container&gt;

      &lt;mat-header-row *matHeaderRowDef&#x3D;&quot;documentsDisplayedColumns&quot;&gt;&lt;/mat-header-row&gt;
      &lt;mat-row *matRowDef&#x3D;&quot;let row; columns: documentsDisplayedColumns;&quot;&gt;&lt;/mat-row&gt;
    &lt;/mat-table&gt;
  &lt;/mat-card-content&gt;
&lt;/mat-card&gt;


&lt;highlighted-question-list [operation]&#x3D;&quot;operation&quot; [readOnly]&#x3D;&quot;readOnly&quot;&gt;&lt;/highlighted-question-list&gt;
</code></pre>
    </div>

    <div class="tab-pane fade " id="c-styleData">
                <p class="comment">
                    <code>../parameter-edit.scss</code>
                </p>
                <pre class="line-numbers"><code class="language-scss">.parameter-edit .mat-card-header {
  min-height: 0;
}

.parameter-edit .mat-card-header &gt; div {
  width: 100%;
}

.parameter-edit .mat-card-content {
  min-height: 0;
}

.parameter-edit .mat-card-actions {
  min-height: 0;
  padding: 0 2rem 2rem;
}

.parameter-input {
  padding: 1rem;
}

.parameter-error {
  font-size: 1.8rem;
  line-height: 3.5rem;
  padding: 1rem;
  margin-top: 1rem;
}

.parameter-error-icon {
  font-size: 3rem;
}


</code></pre>
                <p class="comment">
                    <code>./document-edit.component.scss</code>
                </p>
                <pre class="line-numbers"><code class="language-scss">.mat-column-type {
  flex: 0 0 20rem;
}

.mat-column-language {
  flex: 0 0 15rem;
}

.mat-column-file {
  flex: 1 0 10rem;
}

.mat-column-delete {
  flex: 0 0 8rem;
}

</code></pre>
    </div>

    <div class="tab-pane fade " id="c-tree">
        <div id="tree-container"></div>
        <div class="tree-legend">
            <div class="title">
                <b>Legend</b>
            </div>
            <div>
                <div class="color htmlelement"></div><span>Html element</span>
            </div>
            <div>
                <div class="color component"></div><span>Component</span>
            </div>
            <div>
                <div class="color directive"></div><span>Html element with directive</span>
            </div>
        </div>
    </div>

    
</div>

<script src="../js/libs/vis.min.js"></script>
<script src="../js/libs/htmlparser.js"></script>
<script src="../js/libs/deep-iterator.js"></script>
<script>
        var COMPONENT_TEMPLATE = '<div><mat-card id="documentEdit" class="parameter-edit" [class.read-only]="readOnly">  <mat-card-header>    <mat-card-title>{{\'parameters.document.edit.title\' | translate}}</mat-card-title>    <mat-card-subtitle fxLayout="row" fxLayoutAlign="space-between">      <span>{{\'parameters.document.edit.subtitle\' | translate}}</span>      <span *ngIf="!readOnly">{{\'global.forms.fields.required\' | translate}}</span>    </mat-card-subtitle>  </mat-card-header>  <mat-card-content class="no-padding">    <ng-container *roles="[\'SET_OPERATION_DOCUMENTATION\']">      <div fxLayout fxLayoutGap="25px" class="parameter-input" *ngIf="!readOnly && !allDocumentsAreImported">        <form [formGroup]="documentForm" novalidate>          <div fxLayout fxLayoutGap="25px">            <mat-form-field fxFlex="1 1 200px">              <mat-select [placeholder]="\'parameters.document.edit.form.fields.type.placeholder\' | translate"                          formControlName="documentType"                          (selectionChange)="updateLanguages()"                          required>                <mat-option *ngFor="let type of documentTypes" [value]="type.value">                  {{type.labelKey | translate}}                </mat-option>              </mat-select>              <mat-error                *ngIf="documentForm.get(\'documentType\').touched && documentForm.get(\'documentType\').hasError(\'required\')">                {{\'global.forms.errors.required\' | translate}}              </mat-error>            </mat-form-field>            <mat-form-field fxFlex="1 1 200px">              <mat-select [placeholder]="\'parameters.document.edit.form.fields.language.placeholder\' | translate"                          formControlName="documentLanguage"                          (selectionChange)="updateTypes()"                          required>                <mat-option *ngFor="let lang of languages" [value]="lang.value">                  {{lang.labelKey | translate}}                </mat-option>              </mat-select>              <mat-error                *ngIf="documentForm.get(\'documentLanguage\').touched && documentForm.get(\'documentLanguage\').hasError(\'required\')">                {{\'global.forms.errors.required\' | translate}}              </mat-error>            </mat-form-field>          </div>        </form>        <upload-input fxFlex="auto" placeholder="parameters.document.edit.form.fields.inputFile.placeholder"                      [uploadUrl]="uploadUrl"                      [checkBeforeUpload]="checkBeforeUpload()"                      fileAccept=".pdf"                      uploadIcon="file_upload"                      uploadText="global.actions.import"                      progressText="global.upload-progress"                      (uploadDone)="processUploadResult($event)">        </upload-input>      </div>    </ng-container>    <mat-table [hidden]="!documents || documents.length === 0"               [dataSource]="documentsDataSource" matSort               id="documentsGrid">      <ng-container matColumnDef="type">        <mat-header-cell *matHeaderCellDef mat-sort-header>          {{"parameters.document.edit.grid.header.type" | translate}}        </mat-header-cell>        <mat-cell *matCellDef="let file">{{file.type}}</mat-cell>      </ng-container>      <ng-container matColumnDef="language">        <mat-header-cell *matHeaderCellDef mat-sort-header>          {{"parameters.document.edit.grid.header.language" | translate}}        </mat-header-cell>        <mat-cell *matCellDef="let file">{{file.language}}</mat-cell>      </ng-container>      <ng-container matColumnDef="file">        <mat-header-cell *matHeaderCellDef mat-sort-header>          {{"parameters.document.edit.grid.header.file" | translate}}        </mat-header-cell>        <mat-cell *matCellDef="let file"><a href="#" (click)="download($event, file)">{{file.fileName}}</a></mat-cell>      </ng-container>      <ng-container matColumnDef="delete">        <mat-header-cell *matHeaderCellDef>          {{"parameters.document.edit.grid.header.delete" | translate}}        </mat-header-cell>        <mat-cell *matCellDef="let file">          <button mat-icon-button                  color="accent"                  (click)="deleteFile(file)">            <mat-icon>clear</mat-icon>          </button>        </mat-cell>      </ng-container>      <mat-header-row *matHeaderRowDef="documentsDisplayedColumns"></mat-header-row>      <mat-row *matRowDef="let row; columns: documentsDisplayedColumns;"></mat-row>    </mat-table>  </mat-card-content></mat-card><highlighted-question-list [operation]="operation" [readOnly]="readOnly"></highlighted-question-list></div>'
    var COMPONENTS = [{'name': 'ActionCardComponent', 'selector': 'action-card'},{'name': 'AdminCardsViewComponent', 'selector': 'admin-cards-view'},{'name': 'AdminComponent', 'selector': 'app-admin'},{'name': 'AdminEditViewComponent', 'selector': 'admin-edit-view'},{'name': 'AppComponent', 'selector': 'app-root'},{'name': 'BallotDocumentationCardComponent', 'selector': 'ballot-documentation-card'},{'name': 'BallotDocumentationEditComponent', 'selector': ''},{'name': 'BaseCardComponent', 'selector': 'base-card'},{'name': 'BaseCreateComponent', 'selector': ''},{'name': 'BaseEditComponent', 'selector': ''},{'name': 'BusinessErrorDialogComponent', 'selector': 'app-business-error-dialog'},{'name': 'CardTitleCardComponent', 'selector': 'card-title-card'},{'name': 'CardTitleEditComponent', 'selector': 'card-title-edit'},{'name': 'CompletableCardComponent', 'selector': 'completable-card'},{'name': 'DashboardComponent', 'selector': ''},{'name': 'DefaultErrorsComponent', 'selector': 'default-errors'},{'name': 'DeploymentSummaryComponent', 'selector': 'deployment-summary'},{'name': 'DocumentCardComponent', 'selector': 'document-card'},{'name': 'DocumentEditComponent', 'selector': ''},{'name': 'DomainInfluenceCardComponent', 'selector': 'domain-influence-card'},{'name': 'DomainInfluenceEditComponent', 'selector': ''},{'name': 'DomainInfluenceGridComponent', 'selector': 'domain-influence-grid'},{'name': 'EditContentComponent', 'selector': 'edit-content'},{'name': 'EditLabelComponent', 'selector': 'edit-label'},{'name': 'EditWithSideBarComponent', 'selector': 'edit-with-side-bar'},{'name': 'ElectionDetailsComponent', 'selector': 'election-details'},{'name': 'ElectionDetailsElectoralListComponent', 'selector': 'election-details-electoral-lists'},{'name': 'ElectionDetailsTableComponent', 'selector': 'election-details-table'},{'name': 'ElectionPagePropertiesCardComponent', 'selector': 'election-page-properties-card'},{'name': 'ElectionPagePropertiesEditComponent', 'selector': 'election-page-properties-edit'},{'name': 'ElectionPagePropertiesMappingComponent', 'selector': 'election-page-properties-mapping'},{'name': 'ElectionPagePropertiesModelEditComponent', 'selector': 'election-page-properties-model-edit'},{'name': 'ElectionPagePropertiesModelListComponent', 'selector': 'election-page-properties-model-list'},{'name': 'ElectoralAuthorityKeyCardComponent', 'selector': 'electoral-authority-key-card'},{'name': 'ElectoralAuthorityKeyListComponent', 'selector': 'electoral-authority-key-list'},{'name': 'GroupedGridComponent', 'selector': 'grouped-grid'},{'name': 'HeaderComponent', 'selector': 'chvote-header'},{'name': 'HighlightedQuestionEditComponent', 'selector': 'highlighted-question-edit'},{'name': 'HighlightedQuestionListComponent', 'selector': 'highlighted-question-list'},{'name': 'KeyViewComponent', 'selector': 'key-view'},{'name': 'LocalizedHighlightedQuestionListComponent', 'selector': 'localized-highlighted-question-list'},{'name': 'LoginComponent', 'selector': ''},{'name': 'ManagementEntityCardComponent', 'selector': 'management-entity-card'},{'name': 'ManagementEntityEditComponent', 'selector': 'management-entity-edit'},{'name': 'ManagementEntityListComponent', 'selector': 'management-entity-list'},{'name': 'ManagementEntitySelectorComponent', 'selector': 'management-entity-selector'},{'name': 'MilestoneCardComponent', 'selector': 'milestone-card'},{'name': 'MilestoneEditComponent', 'selector': ''},{'name': 'ModelSelectorComponent', 'selector': 'election-page-bulk-update'},{'name': 'OperationListComponent', 'selector': 'operation-list'},{'name': 'OperationManagementComponent', 'selector': ''},{'name': 'ParametersComponent', 'selector': 'parameters'},{'name': 'ParametersEditComponent', 'selector': ''},{'name': 'ParametersNotificationComponent', 'selector': 'parameters-notification'},{'name': 'PrinterCardComponent', 'selector': 'printer-card'},{'name': 'PrinterEditComponent', 'selector': 'printer-edit'},{'name': 'PrinterViewComponent', 'selector': 'printer-view'},{'name': 'ProductionSummaryComponent', 'selector': 'production-summary'},{'name': 'RegisterCardComponent', 'selector': 'register-card'},{'name': 'RegisterListComponent', 'selector': 'register-list'},{'name': 'RegisterUploadComponent', 'selector': 'register-upload'},{'name': 'RepositoryCardComponent', 'selector': 'repository-card'},{'name': 'RepositoryEditComponent', 'selector': ''},{'name': 'SelectedElectoralAuthorityKeyCardComponent', 'selector': 'selected-electoral-authority-key-card'},{'name': 'SelectedElectoralAuthorityKeyEditComponent', 'selector': 'selected-electoral-authority-key-edit'},{'name': 'SideBarBackButtonComponent', 'selector': 'side-bar-back-button'},{'name': 'SideBarItemComponent', 'selector': 'side-bar-item'},{'name': 'SlideDetailsComponent', 'selector': 'slide-details'},{'name': 'SlideDetailsContentComponent', 'selector': 'slide-details-content'},{'name': 'SlideDetailsDetailsComponent', 'selector': 'slide-details-details'},{'name': 'SmallProgressSpinnerComponent', 'selector': 'small-progress-spinner'},{'name': 'TallyComponent', 'selector': 'tally'},{'name': 'TechnicalErrorDialogComponent', 'selector': 'app-technical-error-dialog'},{'name': 'TestingCardsLotCardComponent', 'selector': 'testing-cards-lot-card'},{'name': 'TestingCardsLotDetailsComponent', 'selector': 'testing-cards-lot-details'},{'name': 'TestingCardsLotListComponent', 'selector': 'testing-cards-lot-list'},{'name': 'TestingCardsLotSideBarItemComponent', 'selector': 'testing-cards-lot-side-bar-item'},{'name': 'TestSiteCardsDownloadButtonComponent', 'selector': 'test-site-cards-download-button'},{'name': 'TestSummaryComponent', 'selector': 'test-summary'},{'name': 'TextWithEditComponent', 'selector': 'text-with-edit'},{'name': 'UploadInputComponent', 'selector': 'upload-input'},{'name': 'VerificationCodeEditComponent', 'selector': 'verification-code-edit'},{'name': 'VotationDetailsComponent', 'selector': 'votation-details'},{'name': 'VotingMaterialComponent', 'selector': ''},{'name': 'VotingMaterialCreationProgressComponent', 'selector': 'voting-material-creation-progress'},{'name': 'VotingMaterialNotificationComponent', 'selector': 'voting-material-notification'},{'name': 'VotingPeriodComponent', 'selector': ''},{'name': 'VotingPeriodNotificationComponent', 'selector': 'voting-period-notification'},{'name': 'VotingSiteConfigurationCardComponent', 'selector': 'voting-site-configuration-card'},{'name': 'VotingSiteConfigurationComponent', 'selector': 'voting-site-configuration-edit'},{'name': 'VotingSitePeriodCardComponent', 'selector': 'voting-site-period-card'},{'name': 'VotingSitePeriodEditComponent', 'selector': 'voting-site-period-edit'},{'name': 'WaitingCover', 'selector': ''}];
    var DIRECTIVES = [{'name': 'CheckRolesDirective', 'selector': '[roles]'}];
    var ACTUAL_COMPONENT = {'name': 'DocumentEditComponent'};
</script>
<script src="../js/tree.js"></script>














                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'component';
            var COMPODOC_CURRENT_PAGE_URL = 'DocumentEditComponent.html';
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
